// figura3.h - Apstraktna klasa obojenih figura u ravni.

#ifndef _figura3_h_
#define _figura3_h_

#include "boja.h"
#include "tacka9.h"
#include <iostream>
using namespace std;

namespace Figure {
  class GNePripada {}; // KLASA GREAKA: Tacka ne pripada figuri.
  inline ostream& operator<<(ostream& it, const GNePripada&)
    { return it << "*** Tacka ne pripada figuri! ***"; }

  class Figura {                                  // KLASA FIGURA:
    static int posId;                             // Poslednji identifikator
    int id;                                       // Identifikator figure.
    Boja b;                                       // Osnovna boja figure.
  public:
    explicit Figura(Boja bb=Boja())               // Nova figura dobija
      : b(bb), id(++posId) {}                     //   nov identifikator.
    Figura(const Figura& fig)                     // Kopija dobija nov
      : b(fig.b), id(++posId) {}                  //   identifikator.
    Figura& operator=(const Figura& fig)          // Levom operandu se ne
      { b = fig.b; return *this; }                //   menja identifikator.
    virtual ~Figura() {}                          // Virtuelan destruktor.
    virtual Figura* kopija() const =0;            // Kopiranje.
    int dohvId() const { return id; }             // Identifikator.
    Boja boja() const { return b; }               // Osnovna boja figure.
    virtual bool pripada(const Tacka& T) const=0; // Da li tacka pripada?
    virtual Boja boja(const Tacka& T) const {     // Boja tacke.
      if (!pripada(T)) throw GNePripada();
      return b;
    }
  }; // class Figura
} // namespace Figure

#endif
