// firma.h - Klasa firmi.

#ifndef _firma_h_
#define _firma_h_

#include "radnik2.h"
#include "firmagr.h"
#include <iostream>
using namespace std;

namespace Trgovina {
  class Firma {
    Radnik** radnici;                        // Niz zaposlenih.
    int kap;                                 // Broj radnih mesta.
    double marza;                            // Iznos mare.
    Firma(const Firma&) {}                   // Ne sme da se kopira.
    void operator=(const Firma&) {}          // Ne sme da se dodeljuje.
 
  public:
    Firma(double mar, int k=10);             // Inicijalizacija.
    ~Firma();                                // Destruktor.
    Firma& zaposli(Radnik* r);               // Zapoljavanje.
    Firma& otpusti(int i) {                  // Otputanje.
      if (i<0 || i>=kap || !radnici[i]) throw GNema();
      delete radnici[i]; radnici[i] = 0;
      return *this;
    }
    double dobit() const;                    // Dobit firme.
    friend ostream& operator<<(ostream& it, const Firma& fir); // Pisanje.
  }; // class
} // namespace

#endif
