// greska.h - Klasa greaka.

#ifndef _greska_h_
#define _greska_h_

#include <iostream>
#include <cstring>
using namespace std;

namespace Usluge {
  class Greska {
    char* poruka;                                    // Tekst poruke.
    void kopiraj(const char* p) {                    // Kopiranje u objekat.
      if (p) { poruka = new char [strlen(p)+1];
               strcpy(poruka, p);
      } else poruka = 0;
    }
    void brisi() { delete [] poruka; poruka = 0; }   // Pranjenje objekta.
  public:                                            // Konstruktori:
    Greska() { poruka = 0; }                         // - podrazumevani,
    Greska(const char* por) { kopiraj(por); }        // - konverzije,
    Greska(const Greska& g) { kopiraj(g.poruka); }   // - kopije.
    virtual ~Greska() { brisi(); }                   // Destruktor.
    Greska& operator=(const Greska& g) {             // Dodela vrednosti.
      if (this != &g) { brisi(); kopiraj(g.poruka); }
      return *this;
    }
  protected:
    virtual void pisi(ostream& it) const {           // Pisanje poruke.
      it << "\n*** " << (poruka ? poruka : "Greska") << " ***\a\n";
    }
    friend ostream& operator<<(ostream& it, const Greska& g)
      { g.pisi(it); return it; }
    bool imaPoruke() const { return poruka != 0; }   // Ima li poruke?
  }; // class Greska
} // namespace Usluge

#endif
