// inventar.C - Metode i funkcije uz klasu inventara.

#include "inventar.h"
#include <cstring>
using namespace std;

void Inventar::kopiraj(const Inventar& inv) {    // Kopiranje u objekat.
  niz = new Zapis* [kap = inv.kap];
  duz = inv.duz;
  for (int i=0; i<duz; i++) niz[i] = new Zapis(*inv.niz[i]);
}

void Inventar::brisi() {                         // Unitavanje objekta.
  for (int i=0; i<duz; delete niz[i++]);
  delete [] niz;
}

Zapis* Inventar::operator[](const char* naziv) { // Dohvatanje zapisa
  for (int i=0; i<duz; i++)                      //   promenljivog objekta.
    if (strcmp(niz[i]->naziv(), naziv) == 0)
      return niz[i];
  return 0;
}

double Inventar::vrednost() const {              // Vrednost svih artikala.
  double v = 0;
  for (int i=0; i<duz; v+=niz[i++]->vrednost());
  return v;
}

ostream& operator<<(ostream& it, const Inventar& inv) { // Pisanje.
  for (int i=0; i<inv.duz; it<<*inv.niz[i++]<<endl);
  return it << "==============================\n"
            << "UKUPNO:   " << inv.vrednost() << "din" << endl;
}
