// izvor.h - Klasa izvora elektricne energije.

#ifndef _izvor_h_
#define _izvor_h_

#include "potrosac1.h"
#include <iostream>
using namespace std;

 
namespace Potrosaci {
  class GIndeks{};                // KLASA GREAKA: Indeks izvan opsega.
  inline ostream& operator<<(ostream& it, const GIndeks&)
    { return it << "*** Nedozvoljen indeks! ***"; }

  class GPreopt {};               // KLASA GREAKA: Preopterecen izvor.
  inline ostream& operator<<(ostream& it, const GPreopt&)
    { return it << "*** Preopterecen izvor! ***"; }

  class Izvor {                                 // KLASA IZVORA:
    Potrosac** niz;                             // Niz potroaca. 
    int kap;                                    // Broj prikljucnih mesta.
    double sna, opt;              // Nazivna snaga i trenutno opterecenje.
    Izvor(const Izvor&) {}                      // Ne sme da se kopira.
    void operator=(const Izvor&) {}             // Ne sme da se dodeljuje.
  public:
    Izvor(double s, int k);                     // Inicijalizacija.
    ~Izvor();                                   // Destruktor.
    double snaga() const { return sna; }        // Nazivna snaga izvora.
    double opterecenje() const { return opt; }  // Trenutno opterecenje.
    int brMesta() const { return kap; }         // Broj prikljucnih mesta.
    Izvor& prikljuci(Potrosac* p, int i);       // Prikljucivanje potroaca.
    friend ostream& operator<<(ostream& it, const Izvor& izv); // Pisanje.
  }; // class
} // namespace

#endif
