// log.h - Klasa logaritama.

#ifndef _log_h_
#define _log_h_

#include "fun2.h"
#include <cmath>
using namespace std;
#include "greska.h"
using Usluge::Greska;

namespace Funkcije {
  class GNemaLog: public Greska {            // KLASA GREAKA:
    double x;                                // Nedozvoljena vrednost.
  public:                                    // Konstruktori.
    GNemaLog(): Greska("Logaritam negativnog broja") {}
    GNemaLog(double x): Greska() { this->x = x; }
    double dohvX() const                     // Uzimanje nedozvoljene
      { return imaPoruke() ? 1 : x; }        //   vrednosti.
  private:
    void pisi(ostream& it) const {           // Pisanje poruke.
      if (imaPoruke()) Greska::pisi(it);
      else it << "\n*** Ne postoji logaritam od " << x << " ***\a\n";
    }
  }; // class GNemaLog

  class Log: public Fun {                    // KLASA LOGARITAMA:
  public:
    double operator()(double x) const {      // Racunanje funkcije.
      if (x <= 0) throw GNemaLog(x);
      return log(x);
    }
  }; // class Log
} // namespace Funkcije

#endif
