// predstava.C - Metode i funkcije uz klasu predstava.

#include "predstava.h"

void Predstava::kopiraj(const Predstava& p) { // Kopiranje u objekat.
  naslov = new char [strlen(p.naslov)+1];
  naslov = strcpy(naslov, p.naslov);
  datum  = p.datum; brRed = p.brRed;
  duzRed = p.duzRed;
  karte  = new Karta** [brRed];
  for (int i=0; i<brRed; i++) {
    karte[i] = new Karta* [duzRed];
    for (int j=0; j<duzRed; j++)
      karte[i][j] = p.karte[i][j] ? new Karta(*p.karte[i][j]) : 0;
  }
}

void Predstava::brisi() {                     // Unitavanje objekta.
  delete [] naslov;
  for (int i=0; i<brRed; i++) {
    for (int j=0; j<duzRed; delete karte[i][j++]);
    delete [] karte[i];
  }
  delete [] karte;
}                                             
 
Predstava::Predstava(const char* nas, long dat, int brR, int duzR) {
  naslov = new char [strlen(nas)+1];          // Konstruktor novog objekta.
  strcpy(naslov, nas);
  datum = dat; brRed = brR; duzRed = duzR;
  karte = new Karta** [brRed];
  for (int i=0; i<brRed; i++) {
    karte[i] = new Karta* [duzRed];
    for (int j=0; j<duzRed; karte[i][j++]=0);
  }
}

bool Predstava::operator+=(const Karta& k) {  // Dodavanje karte.
  int red = k.dohvRed(), sed = k.dohvSed();
  if (red<0 || red>=brRed || sed<0 || sed>=duzRed || karte[red][sed])
    return false;
  karte[red][sed] = new Karta(k);
  return true;
}

float Predstava::vrednost() const {           // Vrednost svih karata.
  float v = 0;
  for (int i=0; i<brRed; i++)
    for (int j=0; j<duzRed; j++)
      if (karte[i][j]) v += karte[i][j]->dohvCena();
  return v;
}

ostream& operator<<(ostream& it, const Predstava& p) { // Pisanje.
  for (int i=0; i<p.brRed; i++) {
    for (int j=0; j<p.duzRed; j++)
      it << (p.karte[i][j] ? '#' : '_') << ' ';
    it << endl;
  }
  return it;
}
