// prosta.h - Klasa prostih naredbi.

#ifndef _prosta_h_
#define _prosta_h_

#include "naredba.h"
#include "izraz.h"
using namespace Izrazi;

namespace Naredbe {
  class Prosta: public Naredba {
    Izraz* izr;                     // Izraz koji se izracunava.
    void pisi(ostream& it) const {  // Pisanje.
      Naredba::pisi(it);
      if (izr) it << *izr;
      it << ";\n";
    }
    void kopiraj(const Prosta& p)   // Kopiranje u objekat.
      { izr = p.izr ? p.izr->kopija() : 0; }
  public:
    Prosta() { izr = 0; }                            // Prazna naredba.
    Prosta(const Izraz& i) { izr = i.kopija(); }     // Inic. izrazom.
    Prosta(const Prosta& p) { kopiraj(p); }          // Konstruktor kopije.
    ~Prosta() { delete izr; izr = 0; }               // Unitavanje.
    Prosta& operator=(const Prosta& p) {                 // Dodela vrednosti
      if (this != &p) { delete izr; kopiraj(p); }
      return *this;
    }
    void radi() const { if (izr) izr->vredn(); }         // Izvravanje.
    Prosta* kopija() const { return new Prosta(*this); } // Kopiranje. 
  }; // class Prosta
} // namespace Naredbe

#endif
