// radnik2.h  Apstraktna klasa radnika.

#ifndef _radnik2_h_
#define _radnik2_h_

#include <cstring>
#include <iostream>
using namespace std;

namespace Trgovina {
  class Radnik {
    char* ime;                               // Ime radnika.
    double procenat;                         // Procenat za platu.
    Radnik(const Radnik&) {}                 // Ne sme da se kopira.
    void operator=(const Radnik&) {}         // Ne sme da se dodeljuje.
  public:
    Radnik(const char* iime, double pproc) { // Inicijalizacija.
      ime = strcpy(new char [strlen(iime)+1], iime);
      procenat = pproc;
    }
    virtual ~Radnik() { delete [] ime; }     // Destruktor.
    virtual double prihod() const =0;        // Ostvareni prihod.
    double plata() const                     // Iznos plate.
      { return prihod() * procenat / 100; }
    friend ostream& operator<<(ostream& it, const Radnik& r) // Pisanje.
      { return it << r.ime << "/" << r.plata(); }
  }; // class
} // namespace

#endif
