// redveza.h - Klasa rednih veza otpornika.

#include "otpornik.h"
#include <iostream>
#include <cstdlib>
using namespace std;

class RedVeza {
  Otpornik* niz;                               // Niz otpornika.
  int kap, duz;                                // Kapacitet i duina niza.
  void kopiraj(const RedVeza& rv);             // Kopiranje u objekat.
  void brisi() { delete [] niz; }              // Brisanje objekta.
public:
  explicit RedVeza (int k=2) {                 // Stvaranje objekta.
    niz = new Otpornik [kap = k];
    duz = 0;
  }
  RedVeza(const RedVeza& rv) { kopiraj(rv); }  // Konstruktor kopije.
  ~RedVeza() { brisi(); }                      // Destruktor.
  RedVeza& operator=(const RedVeza& rv) {      // Dodela vrednosti.
    if (this != &rv) { brisi(); kopiraj(rv); }
    return *this;
  }                                            // Dohvatanje:
  int dohvKap() const { return kap; }          // - kapaciteta veze,
  int dohvDuz() const { return duz; }          // - duine veze.
  RedVeza& operator+=(const Otpornik& r) {     // Dodavanje otpornika.
    if (duz == kap) exit(1);
    niz[duz++] = r;
    return *this;
  }
  double otp() const;                          // Otpornost veze.
  Otpornik& operator[](int i) {                // Pristup elementu veze:
    if (i<0 || i>=duz) exit(2);                // - promenljivog objekta,
    return niz[i];
  }
  const Otpornik& operator[](int i) const {    // - nepromenljivog objekta.
    if (i<0 || i>=duz) exit(2);
    return niz[i];
  }
  RedVeza& izbaci();                      // Izbacivanje nultih otpornosti.
  friend ostream& operator<<(ostream& it, const RedVeza& rv);   // Pisanje.
};
