// skuptroug.h - Klasa skupova trouglova u ravni.

#include "trougao3.h"
#include <iostream>
using namespace std;

class SkupTroug {
  struct Elem {                              // Element liste.
    Trougao t; Elem* sled;
    Elem(const Trougao& tt): t(tt), sled(0) {}
  };
  Elem *prvi, *posl;                         // Pocetak i kraj liste.
  void kopiraj(const SkupTroug& s);          // Kopiranje u objekat.
  void brisi();                              // Brisanje objekta.
public:
  SkupTroug() { prvi = posl = 0; }           // Stvaranje praznog skupa.
  SkupTroug(const SkupTroug& s)              // Konstruktor kopije.
    { kopiraj(s); }
  ~SkupTroug() { brisi(); }                  // Destruktor.
  SkupTroug& operator=(const SkupTroug& s) { // Dodela vrednosti.
    if (this != &s){ brisi(); kopiraj(s); }
    return *this;
  }
  bool ima(const Trougao& t) const;          // Da li postoji u skupu?
  SkupTroug& operator+=(const Trougao& t);   // Dodavanje trougla.
  double ukP() const;                        // Ukupna povrina trouglova.
  friend ostream& operator<<(ostream& it, const SkupTroug& s); // Pisanje.
};
