// voz1.h - Klasa vozova.

#ifndef _voz1_h_
#define _voz1_h_

#include "vozilo2.h"
#include "lokomot1.h"
#include "pvagon.h"
#include <iostream>
#include <cstring>
using namespace std;

namespace Vozovi1 {
  class GImaLok {};   // KLASA GREAKA: Vec postoji lokomotiva.
  inline ostream& operator<<(ostream& it, const GImaLok)
    { return it << "*** Vec ima lokomotive! ***"; }

  class GNemaLok {};  // KLASA GREAKA: Jo nema lokomotive.
  inline ostream& operator<<(ostream& it, const GNemaLok)
    { return it << "*** Jos nema lokomotive! ***"; }

  class GTezakVoz {}; // KLASA GREAKA: Lokomotiva je preopterecena.
  inline ostream& operator<<(ostream& it, const GTezakVoz)
    { return it << "*** Pretezak voz! ***"; }

  class Voz {                   // KLASA VOZOVA:
    char* ime;                  // Ime voza.
    struct Elem {               // Element liste vozila.
      Vozilo* vozilo; Elem* sled;
      Elem(Vozilo* v) { vozilo = v; sled = 0; }
      ~Elem(){ delete vozilo; }
    };
    Elem *prvi, *posl;          // Prvi i poslednji element liste.
    void kopiraj(const Voz& v); // Kopiranje u objekat.
    void brisi();               // Brisanje objekta.
  public:
    Voz(const char* im) {                    // Inicijalizacija.
      prvi = posl = 0;
      ime = new char [strlen(im)+1];
      strcpy(ime, im);
    }
    Voz(const Voz& v) { kopiraj(v); }        // Konstruktor kopije.
    ~Voz() { brisi(); }                      // Destruktor.
    Voz& operator=(const Voz&v) {            // Dodela vrednosti.
      if (this != &v) { brisi(); kopiraj(v); }
      return *this;
    }
    Voz& operator+=(const Lokomot& lok);     // Dodavanje lokomotive.
    Voz& operator+=(const PVagon& pvag);     // Dodavanje putnickog vagona.
    float ukTezVoza() const;                 // Ukupna teina voza.
    friend ostream& operator<<(ostream& it,const Voz& v); // Pisanje.
  }; // class
} // namespace

#endif
